package org.gatein.rest;


import java.io.File;
import java.nio.file.Paths;

import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.StatusLine;
import org.apache.http.auth.AuthScope;
import org.apache.http.auth.UsernamePasswordCredentials;
import org.apache.http.client.methods.HttpPut;

import static org.junit.Assert.*;

import org.apache.http.entity.FileEntity;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.HttpConnectionParams;
import org.junit.Before;
import org.junit.Test;
import org.junit.After;

public class TemplateRestAPITest {

    final int TIMEOUT = 10000;
    final String URL = "http://localhost:8080/rest/private/managed-components/template/user";
    final String USER = "root";
    final String PASSWORD = "gtn";
    final String TEST_FILE_PATH = "/user.zip";

    DefaultHttpClient client;
    UsernamePasswordCredentials credentials;
    AuthScope authScope;

    @Before
    public void prepareTest() {
        client = new DefaultHttpClient();
        HttpConnectionParams.setConnectionTimeout(client.getParams(), TIMEOUT);
        credentials = new UsernamePasswordCredentials(USER, PASSWORD);
        authScope = new AuthScope(AuthScope.ANY_HOST, AuthScope.ANY_PORT);
        client.getCredentialsProvider().setCredentials(authScope, credentials);
    }

    @After
    public void finishTest() {
        client.getConnectionManager().shutdown();
    }

    @Test
    public void testBufferOverflowException() throws Exception {

        File f = new File(getClass().getResource(TEST_FILE_PATH).toURI());

        assertTrue(TEST_FILE_PATH + " not found", f.exists());

        HttpPut put = new HttpPut(URL);
        put.addHeader("Content-Type", "application/zip");
        put.setEntity(new FileEntity(f));

        HttpResponse response = client.execute(put);
        StatusLine status = response.getStatusLine();

        assertEquals(HttpStatus.SC_OK, status.getStatusCode());
    }
}